package dev.shadowsoffire.apotheosis.adventure.affix.salvaging;

package .var.folders._j.vfbv187d0bb8b8w5spzgg8180000gn.T;

import dev.shadowsoffire.apotheosis.adventure.affix.salvaging.SalvagingMenu;
import dev.shadowsoffire.apotheosis.adventure.affix.salvaging.SalvagingTableTile;
import it.unimi.dsi.fastutil.ints.IntOpenHashSet;
import java.util.List;
import net.minecraft.world.item.ItemStack;
import net.minecraftforge.items.IItemHandler;

public class SalvagingItemHandler implements IItemHandler {
  public int getSlots() {
    return 1 + SalvagingTableTile.this.output.getSlots();
  }
  
  public ItemStack getStackInSlot(int slot) {
    if (slot == 0)
      return ItemStack.f_41583_; 
    return SalvagingTableTile.this.output.getStackInSlot(slot - 1);
  }
  
  public ItemStack insertItem(int slot, ItemStack stack, boolean simulate) {
    if (slot != 0)
      return stack; 
    List<ItemStack> outputs = SalvagingMenu.getBestPossibleSalvageResults(SalvagingTableTile.access$000(SalvagingTableTile.this), stack);
    if (outputs.isEmpty())
      return stack; 
    IntOpenHashSet intOpenHashSet = new IntOpenHashSet();
    for (ItemStack out : outputs) {
      for (int i = 0; i < 6; i++) {
        if (!intOpenHashSet.contains(i)) {
          int size = out.m_41613_();
          out = SalvagingTableTile.this.output.insertItem(i, out, true);
          if (size != out.m_41613_())
            intOpenHashSet.add(i); 
          if (out.m_41619_())
            break; 
        } 
      } 
      if (!out.m_41619_())
        return stack; 
    } 
    if (!simulate)
      for (ItemStack out : outputs) {
        for (int i = 0; i < 6; i++) {
          out = SalvagingTableTile.this.output.insertItem(i, out, false);
          if (out.m_41619_())
            break; 
        } 
        if (!out.m_41619_())
          return stack; 
      }  
    return ItemStack.f_41583_;
  }
  
  public ItemStack extractItem(int slot, int amount, boolean simulate) {
    if (slot == 0)
      return ItemStack.f_41583_; 
    return SalvagingTableTile.this.output.extractItem(slot - 1, amount, simulate);
  }
  
  public int getSlotLimit(int slot) {
    if (slot == 0)
      return 1; 
    return SalvagingTableTile.this.output.getSlotLimit(slot - 1);
  }
  
  public boolean isItemValid(int slot, ItemStack stack) {
    if (slot == 0)
      return (SalvagingMenu.findMatch(SalvagingTableTile.access$100(SalvagingTableTile.this), stack) != null); 
    return false;
  }
}
